VERSION 2.00
Begin Form CantSeeMe 
   BackColor       =   &H00FFFFFF&
   ClientHeight    =   465
   ClientLeft      =   90
   ClientTop       =   1425
   ClientWidth     =   8610
   ControlBox      =   0   'False
   ForeColor       =   &H00FFFFFF&
   Height          =   930
   Icon            =   MAIN.FRX:0000
   Left            =   0
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   465
   ScaleWidth      =   8610
   Top             =   1050
   Visible         =   0   'False
   Width           =   8790
   Begin CommonDialog CDlg 
      CancelError     =   -1  'True
      DialogTitle     =   "Select Database Definition File"
      Filter          =   "Access Definition (*.ADF)|*.ADF|All Files (*.*)|*.*"
      FilterIndex     =   1
      Flags           =   14340
      Left            =   0
      Top             =   0
   End
   Begin Label lb 
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFFFF&
      Caption         =   "U. Muehlenweg GmbH    Kempener Allee 5    47803 Krefeld    Telefon +49(0)2151 750459"
      Height          =   195
      Left            =   675
      TabIndex        =   0
      Top             =   150
      Width           =   7650
   End
End
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'This little Program creates Access Databases from a description file.
'The names and attributes of the Databese(s) and of Tables, Fields and Indexes
'are described in a sequential Text-File.

'A typical file might look like this:

'-----------------------------------------'
'   Database BASENAME.MDB                 '
'     Table Customers                     '
'       Fields                            '      Field Types may be abbreviated to 3 chars.
'         CustNumb=Long,c                 '      c = Counter (only for Long Field Type)
'         Name=String*24                  '      For valid field types see: Sub MakeDatabase
'         First Name=String*24            '      Length reqired for Strings
'         Initial=Byte                    '
'         Address=String*36               '
'         City=String*24                  '      You can define more than one DB per Def-File
'         Zip=String*8                    '
'         ThisYearAccumulated=Currency    '
'         TotalAccumulated=Currency       '
'       Indexes                           '
'         Customer=CustNumb,pu            '      p = Primary   u = Unique
'         Name=Name;First Name            '
'         ZipCode=Zip                     '
'     Table Invoices                      '
'       Fields                            '
'         CustNumb=Long                   '
'         InvoiceNumb=Long                '
'         InvoiceDat=Date                 '
'         InvoiceAmount=Currency          '
'         InvoiceTax=Integer              '
'       Indexes                           '
'         Invoice=CustNumb;InvoiceNumb,p  '
'         Date=-InvoiceDat                '      Minus(-) for descending
'-----------------------------------------'

'The Database(s) will be created in the same diretory with the Definition File.
'You might want to name the Definition File with the extension .ADF because
'that is what it looks for by default.

'Feel free to experiment. The program may not be quite watertight since it
'will almost certainly only be used by professionals. And they should know
'what's wrong if something is wrong.

'Your comments are welcome. Send them to Ulli Muehlenweg  CIS 100331,1413

'DISCLAIMER:
'  THE AUTHOR TAKES NO RESPONSIBILITY FOR DAMAGES OF ANY KIND THAT MAY RESULT
'  FROM THE USE OR FROM THE UNFITNESS FOR USE OF THIS PROGRAM.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit : DefInt A-Z

 Const locale = ";LangID=0x0809;CP=1252;Country=0"        'select from below

'DB_LANG_GENERAL   = ";LANGID=0x0809;CP=1252;COUNTRY=0"   'part of Datacons.TXT
'DB_LANG_SPANISH   = ";LANGID=0x040A;CP=1252;COUNTRY=0"
'DB_LANG_DUTCH     = ";LANGID=0x0413;CP=1252;COUNTRY=0"
'DB_LANG_SWEDFIN   = ";LANGID=0x040C;CP=1252;COUNTRY=0"   'VB3 and Access 1.1 Databases
'DB_LANG_NORWDAN   = ";LANGID=0x0414;CP=1252;COUNTRY=0"   'VB3 and Access 1.1 Databases
'DB_LANG_ICELANDIC = ";LANGID=0x040F;CP=1252;COUNTRY=0"   'VB3 and Access 1.1 Databases

 Const ED = "Error detected "

 Dim InputLine As String, InputType, Status, Action As String, ErrorMsg As String, OK
 Dim Busy, LineNumber, Pointer, SavedError

 Dim DbDef  As Database, DbName As String
 Dim TbDef  As TableDef, TbName As String
 Dim FieldName As String, FieldType, FieldLength, FieldAttr
 Dim IndexName As String, IndexFields As String, IndexUnique, IndexPrimary

Sub CloseDb ()

    DbDef.Close
    If Not OK Then
	KillDatabase
    End If

End Sub

Sub CreateDatabaseDef ()

    KillDatabase                                'Kill Database if exists
    Set DbDef = CreateDatabase(DbName, locale)  'create a new Database

End Sub

Sub CreateFieldDef ()

  Dim NewField As New Field

    NewField.Name = FieldName                  'create a new field
    NewField.Type = FieldType
    NewField.Size = FieldLength
    If FieldAttr Then
	If FieldType = 4 Then                  'fieldtype Long
	    NewField.Attributes = NewField.Attributes Or 16
	  Else
	    Error 639                       'Field type is illegal - only Longs may be Counters
					    'Fields.Append doesn't catch this error
	End If
    End If
    TbDef.Fields.Append NewField            'and put it in the Fields Collection

End Sub

Sub CreateIndexDef ()

  Dim NewIndex As New Index

    NewIndex.Name = IndexName                  'create a new Index
    NewIndex.Fields = IndexFields
    NewIndex.Unique = IndexUnique
    NewIndex.Primary = IndexPrimary
    TbDef.Indexes.Append NewIndex           'and put it in the Indexes Collection

End Sub

Sub CreateTableDef ()

  Dim NewTable As New TableDef              'create a new table

    NewTable.Name = TbName
    Set TbDef = NewTable

End Sub

Sub Form_Load ()

    On Error Resume Next
      CDlg.Action = 2  'File Dlg
      SavedError = Err
    On Error GoTo 0

    If SavedError Then
	MsgBox "Job canceled by User.", 16, "Cancel"
      Else
	Busy = True
	On Error Resume Next
	  Open CDlg.Filename For Input As #1
	  SavedError = Err
	On Error GoTo 0
	If SavedError Then
	    MsgBox "Cannot find " & CDlg.Filename & ".", 16, "Error"
	  Else
	    If MakeDatabase() Then     'returns True if OK
		MsgBox "Database(s) successfully created.", 64, "O.K."
	      Else
		MsgBox "No Database created.", 48, "Error"
	    End If
	    Close #1
	End If
	Busy = False
    End If
    End

End Sub

Sub Form_QueryUnload (Cancel As Integer, UnloadMode As Integer)

    If Busy Then
	Cancel = True
	MsgBox "Hey! Wait a minute, I'm still busy creating a Database for you !", 48, "Busy"
    End If
	
End Sub

Sub KillDatabase ()

    On Error Resume Next
     Kill DbName
    On Error GoTo 0

End Sub

Function MakeDatabase () As Integer  'returns True if OK

'   this is the State Transition Table which contains the sequence logic for the parser

    Const STT = "a 2 11 11 11  1 10k22b 3 32 42  2g20k52b53  4 53  3 50k62 63  4 63d 5g60i 2j 3  5  6d 5h 0a72b73 75  6e 7h70i 2j 3 35  7e 7h 0"   'don't alter unless you've understood how it works
'                ---------1--------=========2========--------3---------=========4========--------5---------=========6========----------7-------
    OK = True
    Screen.MousePointer = 11
    Status = 1
    LineNumber = 0
    On Error GoTo CatchError
    Do
	Do
	If EOF(1) Then
	    InputType = 5
	    Exit Do
	  Else
	     Line Input #1, InputLine
		LineNumber = LineNumber + 1
		InputLine = Trim$(InputLine) & " "
		Pointer = InStr(InputLine, " ")
		Select Case LCase$(Left$(InputLine, Pointer - 1))
		  Case "database": InputType = 0
		  Case "table":    InputType = 1
		  Case "fields":   InputType = 2
		  Case "indexes":  InputType = 3
		  Case Else:       InputType = 4
		End Select
	    End If
	Loop While Len(InputLine) = 1                   'that is the one appended blank
    
	Pointer = Status * 18 + InputType * 3 - 17      'STT location from Status and Input type
	Action = Mid$(STT, Pointer, 1)
	ErrorMsg = Mid$(STT, Pointer + 1, 1)            'get Action, Error, Status from STT
	Status = Val(Mid$(STT, Pointer + 2, 1))

	Select Case ErrorMsg                            'picked up an Error ?
	  Case "1": ErrorMsg = "No Database Name specified."
	  Case "2": ErrorMsg = "No Table specified for Database."
	  Case "3": ErrorMsg = "No Table specified for Field."
	  Case "4": ErrorMsg = "No Table specified for Index."
	  Case "5": ErrorMsg = "No Fields in Table."
	  Case "6": ErrorMsg = "No Fieldnames found."
	  Case "7": ErrorMsg = "No Indexnames found."
	End Select
	If ErrorMsg <> " " Then
	    MsgBox ED & "in Line " & LineNumber & String$(2, 10) & ErrorMsg, 48, "Error"
	    OK = False
	End If
	Select Case Action                              'perform action as from STT
	  Case "a"
	    DbName = Trim$(Mid$(InputLine, 9))
	    CreateDatabaseDef
	  Case "b"
	    TbName = Trim$(Mid$(InputLine, 6))
	    CreateTableDef
	  Case "c"
	    DbDef.TableDefs.Append TbDef
	  Case "d"                                      'disassemble Field line
	    Pointer = InStr(InputLine, "=")
	    FieldName = Trim$(Left$(InputLine, Pointer - 1))
	    InputLine = LTrim$(Mid$(InputLine, Pointer + 1))
	    Select Case LCase$(Left$(InputLine, 3))     'decide field type
	      Case "boo": FieldType = 1                 'bool
	      Case "byt": FieldType = 2                 'byte
	      Case "int": FieldType = 3                 'integer
	      Case "lon": FieldType = 4                 'long
	      Case "cur": FieldType = 5                 'currency
	      Case "sin": FieldType = 6                 'single
	      Case "dou": FieldType = 7                 'double
	      Case "dat": FieldType = 8                 'date/time
	      Case "str": FieldType = 10                'string (*size required)
	      Case "bin": FieldType = 11                'blOb
	      Case "mem": FieldType = 12                'memo
	      Case Else:  Error 639                     'Invalid field type
	    End Select
	    Pointer = InStr(InputLine, "*")             'get field size
	    If Pointer Then
		FieldLength = Val(Mid$(InputLine, Pointer + 1))
	      Else
		FieldLength = 0
	    End If
	    Pointer = InStr(InputLine & ",", ",")
	    InputLine = Mid$(InputLine, Pointer)
	    FieldAttr = InStr(LCase$(InputLine), "c")   'counter field
	    CreateFieldDef
	  Case "e"                                      'disassemble Index line
	    Pointer = InStr(InputLine, "=")
	    IndexName = Trim$(Left$(InputLine, Pointer - 1))
	    InputLine = Mid$(InputLine, Pointer + 1) & ","
	    Pointer = InStr(InputLine, ",")
	    IndexFields = Trim$(Left$(InputLine, Pointer - 1))
	    InputLine = Mid$(InputLine, Pointer + 1)
	    IndexUnique = InStr(LCase$(InputLine), "u")
	    IndexPrimary = InStr(LCase$(InputLine), "p")
	    CreateIndexDef
	  Case "f"
	    CloseDb
	  Case "g"
	    Kill DbName
	  Case "h"
	    DbDef.TableDefs.Append TbDef                'put Table in TableDefs Collection
	    CloseDb
	  Case "i"
	    DbDef.TableDefs.Append TbDef
	    CloseDb
	    DbName = Trim$(Mid$(InputLine, 9))
	    CreateDatabaseDef
	  Case "j"
	    DbDef.TableDefs.Append TbDef
	    TbName = Trim$(Mid$(InputLine, 6))
	    CreateTableDef
	  Case "k"
	    Kill DbName
	    CreateDatabaseDef
	End Select
    Loop Until Status = 0                               'status 0 is at end of file
    Screen.MousePointer = 0                             'so get out
    MakeDatabase = OK

Exit Function

CatchError:                                             'also catches Errors from Subs below

    MsgBox ED & "near Line " & LineNumber & String$(2, 10) & Error, 48, "Error"
    OK = False
    Resume Next

End Function

